Description

As discussed on the last Code Sprint, some schema based validation similar to 
http://json-schema.org/ for arrays would be very useful for FLOW3.

Goal
The JSON schema should be used to verify the syntax of:

    -  Settings
    -  Routes
    -  Image Processing Instructions
    -  Content Type Definitions
    -  Security Settings

Currently a typo in those sometimes leads to very confusing effects. By validation against a pre-made schema, we can tell the user
meaningful errors. We could even integrate that in the exception handling: If an exception happens, we could validate the
configuration, as an error in configuration most likely results in exceptions.

Generally, we want to use schemata to validate arrays.

Specification
we should forward-port JSON-schema from http://tools.ietf.org/html/draft-zyp-json-schema-03 to PHP. We are only listing the
differences here. We will refer to this work as PHP schema. Some major differences are:

    -  JSON schema validation does only distinguish between valid and invalid. We should furthermore have a third, in-between style;
something like "Bad smell", which hints to errors. TODO how to implement it?
    -  We aim for an implementation of 1. - 5.25 of JSON Schema Draft 03.

3.1. Terminology
For this specification, schema will be used to denote a PHP Schema
definition, and an instance refers to a PHP value that the schema
will be describing and validating.

5.8. dependencies
    -  TODO do we need them?

5.20 default
    -  We don't need this.

5.23 format
We support the following additional formats:

    -  classname: A class name which is known to the object manager // TODO: should it be classname or objectname?
5.26. extends, 5.27 id, 5.28. ref, 5.29 $schema
    -  We don't need this.

6 Hyper Schema
    -  We don't need this.

Implementation
Implementation-wise, the validator should be split into two parts: One for the implementation of the PHP schema, the second part for
the FLOW3-specific additions.

    -  We should use \FLOW3\FLOW3\Error\Result
    -  the system should be developed test-driven.

Future Work
The schema could even be self-learning to some extend (see https://github.com/kore/XML-Schema-learner for a similar example).

Related issues:
related to TYPO3.ElasticSearch - Bug # 37844: Always/Globally check respone f... New 2012-06-08
duplicated by TYPO3.Flow - Feature # 5068: Implement validation for settings ... Resolved 2009-10-21

Associated revisions
Revision 1c8a80de - 2012-06-18 12:13 - Martin Ficzel

[FEATURE] Configuration validation through (adapted) JSON Schema

Implementation of a PHP array schema validator modeled using the
JSON Schema specification as guideline.

The following CLI commands which utilize the validator are provided:

- configuration:validate validates the configuration of a certain type
  with respect to the provided schemata. The schema files are searched
  for in Resources/Private/Schema of all active packages.

- configuration:generateschema is a kickstarter which generates a basic
  schema to be used as a starting point for further adjustments

Furthermore, this change includes schemata for all FLOW3 settings and the other
configuration types (Caches, Objects, Policy and Routes).

Change-Id: I542144f9af22c87a5d7712eaba85c453f736838d
Resolves: #31277
Releases: 1.1, 1.2

Revision 37145b1f - 2012-06-18 16:37 - Martin Ficzel

[FEATURE] Configuration validation through (adapted) JSON Schema

Implementation of a PHP array schema validator modeled using the
JSON Schema specification as guideline.

2015-08-03 2/5

https://github.com/kore/XML-Schema-learner


The following CLI commands which utilize the validator are provided:

- configuration:validate validates the configuration of a certain type
  with respect to the provided schemata. The schema files are searched
  for in Resources/Private/Schema of all active packages.

- configuration:generateschema is a kickstarter which generates a basic
  schema to be used as a starting point for further adjustments

Furthermore, this change includes schemata for all FLOW3 settings and the other
configuration types (Caches, Objects, Policy and Routes).

Change-Id: I542144f9af22c87a5d7712eaba85c453f736838d
Resolves: #31277
Releases: 1.1, 1.2

History
#1 - 2011-11-23 13:36 - Bastian Waidelich
- Assigned To set to Rens Admiraal

#2 - 2011-11-23 14:16 - Sebastian Kurfuerst

Rens wants to implement this :) Sebastian will be around for questions.

#3 - 2011-12-22 15:38 - Rens Admiraal
- Assigned To changed from Rens Admiraal to Thomas Hempel

#4 - 2012-03-19 10:51 - Karsten Dambekalns
- Status changed from New to Accepted

#5 - 2012-06-06 13:55 - Martin Ficzel

The development-state of this feature can be seen here https://github.com/mficzel/FLOW3.configurationValidation

#6 - 2012-06-06 22:50 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#7 - 2012-06-07 20:18 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#8 - 2012-06-08 13:30 - Gerrit Code Review

2015-08-03 3/5

https://github.com/mficzel/FLOW3.configurationValidation
http://review.typo3.org/11858
http://review.typo3.org/11858


Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#9 - 2012-06-08 14:09 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#10 - 2012-06-08 14:35 - Martin Ficzel
- Assigned To changed from Thomas Hempel to Martin Ficzel

#11 - 2012-06-08 17:26 - Karsten Dambekalns
- Target version set to 2.0 beta 1

#12 - 2012-06-08 18:53 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#13 - 2012-06-09 18:33 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#14 - 2012-06-12 16:42 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#15 - 2012-06-12 18:20 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#16 - 2012-06-13 11:44 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#17 - 2012-06-18 12:13 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/11858

#18 - 2012-06-18 12:15 - Gerrit Code Review
Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12159

#19 - 2012-06-18 12:37 - Martin Ficzel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:1c8a80de60bff7ad0f878ade7e1cedc0f28ee365.

#20 - 2012-06-18 16:42 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12159

#21 - 2012-06-18 19:38 - Martin Ficzel
- Status changed from Under Review to Resolved

Applied in changeset commit:37145b1f83e3828095f2b584ecc02a0eed3cb551.
